JMeterGUIComponent (Apache JMeter dist API)
Description: declaration: package: org.apache.jmeter.gui, interface: JMeterGUIComponent

Package org.apache.jmeter.gui

# Interface JMeterGUIComponent

All Superinterfaces:
  `ClearGui`

All Known Implementing Classes:
  `AbstractAssertionGui`, `AbstractConfigGui`, `AbstractControllerGui`, `AbstractJMeterGuiComponent`, `AbstractListenerGui`, `AbstractPostProcessorGui`, `AbstractPreProcessorGui`, `AbstractRandomTimerGui`, `AbstractSamplerGui`, `AbstractScopedJMeterGuiComponent`, `AbstractThreadGroupGui`, `AbstractTimerGui`, `AbstractVisualizer`, `AjpSamplerGui`, `AnchorModifierGui`, `ArgumentsPanel`, `AssertionGui`, `AssertionVisualizer`, `AuthPanel`, `BackendListenerGui`, `BeanShellAssertionGui`, `BeanShellSamplerGui`, `BoundaryExtractorGui`, `CacheManagerGui`, `ComparisonVisualizer`, `ConstantTimerGui`, `CookiePanel`, `CounterConfigGui`, `CriticalSectionControllerGui`, `DNSCachePanel`, `DurationAssertionGui`, `ForeachControlPanel`, `FtpConfigGui`, `FtpTestSamplerGui`, `GaussianRandomTimerGui`, `GraphQLHTTPSamplerGui`, `GraphVisualizer`, `HeaderPanel`, `HTMLAssertionGui`, `HtmlExtractorGui`, `HTTPArgumentsPanel`, `HttpDefaultsGui`, `HttpMirrorControlGui`, `HttpTestSampleGui`, `IfControllerPanel`, `IncludeControllerGui`, `InterleaveControlGui`, `JavaConfigGui`, `JavaTestSamplerGui`, `JMESPathAssertionGui`, `JMESPathExtractorGui`, `JMSPublisherGui`, `JMSSamplerGui`, `JMSSubscriberGui`, `JSONPathAssertionGui`, `JSONPostProcessorGui`, `JUnitTestSamplerGui`, `LDAPArgumentsPanel`, `LdapConfigGui`, `LdapExtConfigGui`, `LdapExtTestSamplerGui`, `LdapTestSamplerGui`, `LogicControllerGui`, `LoginConfigGui`, `LoopControlPanel`, `MailerVisualizer`, `MailReaderSamplerGui`, `MD5HexAssertionGUI`, `ModuleControllerGui`, `NamePanel`, `ObsoleteGui`, `OnceOnlyControllerGui`, `PoissonRandomTimerGui`, `PostThreadGroupGui`, `PropertyControlGui`, `ProxyControlGui`, `RandomControlGui`, `RandomOrderControllerGui`, `RecordController`, `RegexExtractorGui`, `RegExUserParametersGui`, `RespTimeGraphVisualizer`, `ResultActionGui`, `ResultSaverGui`, `RunTimeGui`, `SampleTimeoutGui`, `SetupThreadGroupGui`, `SimpleConfigGui`, `SimpleDataWriter`, `SizeAssertionGui`, `SMIMEAssertionGui`, `SmtpSamplerGui`, `StatGraphVisualizer`, `StaticJMeterGUIComponent`, `StatVisualizer`, `SummariserGui`, `SummaryReport`, `SwitchControllerGui`, `SystemSamplerGui`, `TableVisualizer`, `TCPConfigGui`, `TCPSamplerGui`, `TestActionGui`, `TestBeanGUI`, `TestFragmentControllerGui`, `TestPlanGui`, `ThreadGroupGui`, `ThroughputControllerGui`, `TransactionControllerGui`, `UniformRandomTimerGui`, `URLRewritingModifierGui`, `UserParametersGui`, `ViewResultsFullVisualizer`, `WhileControllerGui`, `WorkBenchGui`, `XMLAssertionGui`, `XMLSchemaAssertionGUI`, `XPath2AssertionGui`, `XPath2ExtractorGui`, `XPathAssertionGui`, `XPathExtractorGui`

public interface JMeterGUIComponent extends ClearGui
Implementing this interface indicates that the class is a JMeter GUI Component. A JMeter GUI Component is essentially the GUI display code associated with a JMeter Test Element. The writer of the component must take care to make the component be consistent with the rest of JMeter's GUI look and feel and behavior. Use of the provided abstract classes is highly recommended to make this task easier.

See Also:
  - `AbstractJMeterGuiComponent`
  - `AbstractConfigGui`
  - `AbstractAssertionGui`
  - `AbstractControllerGui`
  - `AbstractTimerGui`
  - `AbstractVisualizer`
  - `AbstractSamplerGui`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default void`
  `assignDefaultValues(org.apache.jmeter.testelement.TestElement element)`
  Configures default values for element after its creation.
  `default boolean`
  `canBeAdded()`
  Returns whether a component of this type can be added to the test plan.
  `void`
  `configure(org.apache.jmeter.testelement.TestElement element)`
  The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data.
  `JPopupMenu`
  `createPopupMenu()`
  When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
  `default org.apache.jmeter.testelement.TestElement`
  `createTestElement()`
  JMeter test components are separated into a model and a GUI representation.
  `String`
  `getDocAnchor()`
  Get the component's document anchor name.
  `String`
  `getLabelResource()`
  Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language.
  `Collection<String>`
  `getMenuCategories()`
  This is the list of add menu categories this gui component will be available under.
  `String`
  `getName()`
  Gets the name of the JMeter GUI component.
  `String`
  `getStaticLabel()`
  Get the component's label.
  `boolean`
  `isEnabled()`
  Test GUI elements can be disabled, in which case they do not become part of the test when run.
  `default org.apache.jmeter.testelement.TestElement`
  `makeTestElement()`
  Creates the test element represented by the GUI component.
  `default void`
  `modifyTestElement(org.apache.jmeter.testelement.TestElement element)`
  GUI components are responsible for populating TestElements they create with the data currently held in the GUI components.
  `void`
  `setEnabled(boolean enabled)`
  Set whether this component is enabled.
  `void`
  `setName(String name)`
  Sets the name of the JMeter GUI Component.

  ### Methods inherited from interface org.apache.jmeter.gui.ClearGui

  `clearGui`

- ## Method Details

  - ### setName

    void setName(String name)
    Sets the name of the JMeter GUI Component. The name of the component is used in the Test Tree as the name of the tree node.
    Parameters:
      `name` - the name of the component

  - ### getName

    String getName()
    Gets the name of the JMeter GUI component. The name of the component is used in the Test Tree as the name of the tree node.
    Returns:
      the name of the component

  - ### getStaticLabel

    String getStaticLabel()
    Get the component's label. This label is used in drop down lists that give the user the option of choosing one type of component in a list of many. It should therefore be a descriptive name for the end user to see. It must be unique to the class. It is also used by Help to find the appropriate location in the documentation. Normally getLabelResource() should be overridden instead of this method; the definition of this method in AbstractJMeterGuiComponent is intended for general use.
    Returns:
      GUI label for the component.
    See Also:
      - `getLabelResource()`

  - ### getLabelResource

    String getLabelResource()
    Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language. The resource name is fixed, and does not vary with the selected language.

    Normally this method should be overridden in preference to overriding getStaticLabel(). However where the resource name is not available or required, getStaticLabel() may be overridden instead.

    Returns:
      the resource name

  - ### getDocAnchor

    String getDocAnchor()
    Get the component's document anchor name. Used by Help to find the appropriate location in the documentation
    Returns:
      Document anchor (#ref) for the component.

  - ### createTestElement

    @API(status=EXPERIMENTAL, since="5.6.3") default org.apache.jmeter.testelement.TestElement createTestElement()
    JMeter test components are separated into a model and a GUI representation. The model holds the data and the GUI displays it. The GUI class is responsible for knowing how to create and initialize with data the model class that it knows how to display, and this method is called when new test elements are created.

    Since 5.6.3, the default implementation is as follows, and subclasses should override `makeTestElement()`

         public TestElement createTestElement() {
             TestElement element = makeTestElement();
             assignDefaultValues(element);
             return el;
         }

    Before 5.6.3 the canonical implementation was as follows, however, it is recommended to avoid overriding `createTestElement()` and override `makeTestElement()` instead.

         public TestElement createTestElement() {
             TestElementXYZ el = new TestElementXYZ();
             modifyTestElement(el);
             return el;
         }

    Returns:
      the Test Element object that the GUI component represents.

  - ### makeTestElement

    @API(status=EXPERIMENTAL, since="5.6.3") default org.apache.jmeter.testelement.TestElement makeTestElement()
    Creates the test element represented by the GUI component.
    Returns:
      a new `TestElement`
    Since:
      5.6.3

  - ### assignDefaultValues

    default void assignDefaultValues(org.apache.jmeter.testelement.TestElement element)
    Configures default values for element after its creation. Plugin authors should call this once in their `createTestElement()` implementation.
    Parameters:
      `element` - test element to configure
    Since:
      5.6.3

  - ### modifyTestElement

    @API(status=EXPERIMENTAL, since="5.6.3") default void modifyTestElement(org.apache.jmeter.testelement.TestElement element)
    GUI components are responsible for populating TestElements they create with the data currently held in the GUI components. This method should overwrite whatever data is currently in the TestElement as it is called after a user has filled out the form elements in the gui with new information.

    If you override `AbstractJMeterGuiComponent`, you might want using `AbstractJMeterGuiComponent.bindingGroup` instead of overriding `modifyTestElement`.

    The canonical implementation looks like this:

         @Override
         public void modifyTestElement(TestElement element) {
             super.modifyTestElement(element); // clear the element and assign basic fields like name, gui class, test class
             // Using the element setters (preferred):
             // If the field is empty, you probably want to remove the property instead of storing an empty string
             // See Streamline binding of UI elements to TestElement properties
             // for more details
             TestElementXYZ xyz = (TestElementXYZ) element;
             xyz.setState(StringUtils.defaultIfEmpty(guiState.getText(), null));
             xyz.setCode(StringUtils.defaultIfEmpty(guiCode.getText(), null));
             ... other GUI fields ...
             // or directly (do not use unless there is no setter for the field):
             element.setProperty(TestElementXYZ.STATE, StringUtils.defaultIfEmpty(guiState.getText(), null))
             element.setProperty(TestElementXYZ.CODE, StringUtils.defaultIfEmpty(guiCode.getText(), null))
             ... other GUI fields ...
         }

    Parameters:
      `element` - the TestElement to modify

  - ### isEnabled

    boolean isEnabled()
    Test GUI elements can be disabled, in which case they do not become part of the test when run.
    Returns:
      true if the element should be part of the test run, false otherwise

  - ### setEnabled

    void setEnabled(boolean enabled)
    Set whether this component is enabled.
    Parameters:
      `enabled` - true for enabled, false for disabled.

  - ### createPopupMenu

    JPopupMenu createPopupMenu()
    When a user right-clicks on the component in the test tree, or selects the edit menu when the component is selected, the component will be asked to return a JPopupMenu that provides all the options available to the user from this component.
    Returns:
      a JPopupMenu appropriate for the component.

  - ### configure

    void configure(org.apache.jmeter.testelement.TestElement element)
    The GUI must be able to extract the data from the TestElement and update all GUI fields to represent those data. This method is called to allow JMeter to show the user the GUI that represents the test element's data.

    The canonical implementation looks like this:

         public void configure(TestElement element) {
             super.configure(element);
             // Using the element getter (preferred):
             TestElementXYZ xyz = (TestElementXYZ) element;
             guiState.setText(xyz.getState());
             guiCode.setText(xyz.getCode());
             ... other GUI fields ...
             // or using the element property names directly (do not use unless there is no getter for the field)
             guiState.setText(element.getPropertyAsString(TestElementXYZ.STATE));
             guiCode.setText(element.getPropertyAsString(TestElementXYZ.CODE));
             ... other GUI fields ...
         }

    Parameters:
      `element` - the TestElement to configure

  - ### getMenuCategories

    Collection<String> getMenuCategories()
    This is the list of add menu categories this gui component will be available under. For instance, if this represents a Controller, then the MenuFactory.CONTROLLERS category should be in the returned collection. When a user right-clicks on a tree element and looks through the "add" menu, which category your GUI component shows up in is determined by which categories are returned by this method. Most GUI's belong to only one category, but it is possible for a component to exist in multiple categories.
    Returns:
      a Collection of Strings, where each element is one of the constants defined in MenuFactory
    See Also:
      - `MenuFactory`

  - ### canBeAdded

    default boolean canBeAdded()
    Returns whether a component of this type can be added to the test plan.
    Returns:
      true if the component can be added, false otherwise.